/*
	Xbar v1.0	Jason Smith 2000
	
	blah blah blah ... GPL  blah blah

*/
#include <stdio.h>
#include <X11/Xatom.h>
#include <X11/Xlib.h>
#include <X11/cursorfont.h> 	// for mouse cursor

char dispname[256] = "\0"; //defaults to local 
char newName[256];
char * oldName;
int screen = 0; // current screen
Display *dpy;
Window MyWin = 0;
Window root = 0;

// The following was blatantly stolen and modified from xchtit
Window Select_Window(Display *dpy)
{
  int status;
  Cursor cursor;
  XEvent event;
  Window target_win = None;
  Window root = 0;
  int buttons = 0;

  screen = DefaultScreen(dpy);
  root = RootWindow(dpy,screen);
  /* Make the target cursor */
  cursor = XCreateFontCursor(dpy, XC_crosshair);

  /* Grab the pointer using target cursor, letting it room all over */
  status = XGrabPointer(dpy, root, False,
                        ButtonPressMask|ButtonReleaseMask, GrabModeSync,
                        GrabModeAsync, root, cursor, CurrentTime);
  //if (status != GrabSuccess) Fatal_Error("Can't grab the mouse.");

  /* Let the user select a window... */
  while ((target_win == None) || (buttons != 0)) {
    /* allow one more event */
    XAllowEvents(dpy, SyncPointer, CurrentTime);
    XWindowEvent(dpy, root, ButtonPressMask|ButtonReleaseMask, &event);
    switch (event.type) {
    case ButtonPress:
      if (target_win == None) {
        target_win = event.xbutton.subwindow; /* window selected */
        if (target_win == None) target_win = root;
      }
      buttons++;
      break;
    case ButtonRelease:
      if (buttons > 0) /* there may have been some down before we started */
        buttons--;
       break;
    }
  }

  XUngrabPointer(dpy, CurrentTime);       
  target_win = XmuClientWindow (dpy, target_win);
  return(target_win);
}

char *SelectedText (Display *dpy, Window MyWin) {
	XEvent event;
	int r;
	Time time;

	//XSelectInput(dpy,MyWin,SelectionNotify);
	XConvertSelection(dpy, XA_PRIMARY, XA_STRING, XA_CUT_BUFFER0, XRootWindow(dpy, DefaultScreen(dpy)), time = CurrentTime);
	XFlush(dpy);
/*
	// This stuff is for the proper way to 
	// wait on the xselection event... 
	// if I had been capturing it... i think
	// the below method works just as well and faster
	if (!event->xselection.property) {
		XNextEvent(dpy, &event);
	}
*/
	sleep(1); // lazy man's wait-on-reply-event();
	return XFetchBuffer(dpy, &r, 0);
}

main (int argc,char **argv) 
{
int i;
int cmdText = 1;
int debug = 0;

// command line processing
for (i=1;i<argc;i++) {
	if (!strcmp(argv[i], "-text")) {
		cmdText = 0; // command line had text 
		strncpy(newName,argv[++i],255);
		newName[255] = '\0'; // just being paranoid
		//printf("new title : %s\n",newName);
	}
	if (!strcmp(argv[i], "-display")) {
		strncpy(dispname,argv[++i],255);
		dispname[255] = '\0'; // no buffer overflows...
		//printf("display : %s\n",dispname);
	}
	if (!strcmp(argv[i], "-v")) {
		debug++;
	}
	if (!strcmp(argv[i], "-h")) {
		printf("Usage: %s -text [new title]\n", argv[0]);
		exit(0);
	}
}


if ((dpy = XOpenDisplay(dispname)) == NULL)  {
	fprintf(stderr,"Unable to open display: %s\n", dispname);
	exit(1);
}

MyWin = Select_Window(dpy);
XFetchName(dpy, MyWin, &oldName);
//XStoreName(dpy, MyWin, newName);
XStoreName(dpy, MyWin, SelectedText(dpy,MyWin));
XFlush(dpy);
if (debug) {
	printf("old name : %s\n",oldName);
}
exit(0); // success
}
